texture DrawTexture;
texture PrecTexture;
float intensity;
int i = 10;

sampler2D g_samSrcColor = sampler_state
{
        texture = <DrawTexture>;
		AddressU = MIRROR;
		AddressV = MIRROR;
};

sampler2D SamplerPrec = sampler_state
{
        texture = <PrecTexture>;
		AddressU = MIRROR;
		AddressV = MIRROR;
};

float2 Center = float2(0.5, 0.5); //centre de l'cran

float4 Degrade(float2 Tex : TEXCOORD0) : COLOR0
{
	float4 Color = tex2D(g_samSrcColor,Tex) * 10;	// je multiplie par 10
	int Color2r = Color.r;	// j'utilise les integer pour tronquer mon resultat
	int Color2g = Color.g;  // qqch qui valait entre 0.7 et 0.7999999 vaut maintenant 7
	int Color2b = Color.b;
	Color.r = Color2r; // je reassigne au floats
	Color.g = Color2g;
	Color.b = Color2b;
	Color = Color / 10;	// je divise par 10 pour revenir entre 1 et 0 mon 7 redeviens 0.7
	return Color;
}

float4 SpeedBlur(float2 Tex : TEXCOORD0) : COLOR0
{
	float4 Color = tex2D(g_samSrcColor, Tex);  //couleur du pixel courant
	float2 PixelToBlur = (Center + ((Tex - Center) / (intensity + 1)));     //pixel qui sera mlang avec le pixel courant
	Color += tex2D(g_samSrcColor,PixelToBlur);
	float2 PixelToBlur1 = (Tex - (Center + ((Tex - Center) / (intensity + 1)))) / 4;     //pixel qui sera mlang avec le pixel courant
	Color += tex2D(g_samSrcColor,PixelToBlur1 + PixelToBlur);
	float2 PixelToBlur2;
	int j;
    int h = 12;
	for (j = 2; j < h; j++)
	{
		PixelToBlur2 = PixelToBlur + j * PixelToBlur1;     //pixel qui sera mlang avec le pixel courant
		Color += tex2D(g_samSrcColor,PixelToBlur2);
	}
	Color = Color / j; // fin du flou de vitesse
	return Color;	// je renvoie
}

float4 None( float2 Tex : TEXCOORD0 ) : COLOR0
{
	float4 Color = tex2D( g_samSrcColor, Tex );
	return Color;
}

float4 MotionBlur( float2 Tex : TEXCOORD0 ) : COLOR0
{
        float4 Color1 = tex2D( g_samSrcColor, Tex );
        float4 Color2 = tex2D( SamplerPrec, Tex );
        float Coef = tanh(40*intensity+0.2);
        return lerp(Color1, Color2, Coef);
}

float4 TheTwo( float2 Tex : TEXCOORD0 ) : COLOR0
{
	float4 Color = tex2D(g_samSrcColor, Tex);  //couleur du pixel courant
	float2 PixelToBlur = (Center + ((Tex - Center) / (2*intensity + 1)));     //pixel qui sera mlang avec le pixel courant
	Color += tex2D(g_samSrcColor,PixelToBlur);
	float2 PixelToBlur1 = (Tex - (Center + ((Tex - Center) / (2*intensity + 1)))) / 4;     //pixel qui sera mlang avec le pixel courant
	Color += tex2D(g_samSrcColor,PixelToBlur1 + PixelToBlur);
	float2 PixelToBlur2;
	int j;
    int h = 6;
	for (j = 2; j < h; j++)
	{
		PixelToBlur2 = PixelToBlur + j * PixelToBlur1;     //pixel qui sera mlang avec le pixel courant
		Color += tex2D(g_samSrcColor,PixelToBlur2);
	}
	float4 Color2 = tex2D( SamplerPrec, Tex );
	Color = lerp(Color/j, Color2, 0.6); // fin du flou de vitesse
	return Color;	// je renvoie
}

technique RADIALBLUR
{
	pass p0
	{
		PixelShader = compile ps_2_0 SpeedBlur();
	}
}

technique MOTIONBLUR
{
        pass p0
        {
            PixelShader = compile ps_2_0 MotionBlur();
        }
}

technique KIKOOLOL
{
        pass p0
        {
                PixelShader = compile ps_2_0 TheTwo();
        }
}

technique Degrade
{
    pass p0
    {
		PixelShader = compile ps_2_0 Degrade();
    }
}

technique NONE
{
	pass p0
	{
		//PixelShader = compile ps_2_0 None();
	}
}
